# SjisChars_Jruby.rb
ReSjis = Regexp.compile('[\x81-\x9f\xe0-\xfc][\x40-\x7e\x80-\xfc]|.')
KU13 = 0x8740..0x879c
KU89_92 = 0xED40..0xEEFC
KU115_9 = 0xFA40..0xFC4B
GAIJI = 0xF040..0xF9FC

class SjisChars < String
  	def each_char
		self.scan(ReSjis) do |c|
			sc = SjisChar.new(c)
			yield sc
		end
	end
end

class SjisChar < String
	def code
		if self.length == 1
			self[0]
		else
			self[0] * 0x100 + self[1]
		end
	end

	def isKisyu
		KU13 === code || KU89_92 === code || KU115_9 === code
	end

	def isGaiji
		GAIJI === code
	end
end
  
SjisChars.new('abc@@\^@K').each_char do |c|
  printf("%s %x, %s, %s\n", c, c.code, c.isKisyu, c.isGaiji)
end

